Why can't I get pgrep output right to variable on bash script?2019 Community Moderator ElectionBash script doesn't TEE output to subdirectoryExiting a Bash script when a sudo child quitsConditional execution block with || and parentheses problemGet PID and return code from 1 line bash callWhy is “Doing an exit 130 is not the same as dying of SIGINT”?bash script: capturing tcp traffic on a remote server sometimes works, sometimes fails. No errorsWhat does typing a single exclamation mark do in Bash?Execute command and store everything to variable in bashWhy does bash 'read' exit with status 1?What does it mean when Duplicity exits with exit status 23?

Connection Between Knot Theory and Number Theory

Why is "la Gestapo" feminine?

What is the tangent at a sharp point on a curve?

"Oh no!" in Latin

Why is participating in the European Parliamentary elections used as a threat?

Not hide and seek

What 1968 Moog synthesizer was used in the Movie Apollo 11?

Put the phone down / Put down the phone

Are hand made posters acceptable in Academia?

When is the exact date for EOL of Ubuntu 14.04 LTS?

What properties make a magic weapon befit a Rogue more than a DEX-based Fighter?

What is it called when someone votes for an option that's not their first choice?

Why is implicit conversion not ambiguous for non-primitive types?

Why didn’t Eve recognize the little cockroach as a living organism?

Taking my research idea outside my paid job

Recursively move files within sub directories

I keep switching characters, how do I stop?

Could a welfare state co-exist with mega corporations?

Extract substring according to regexp with sed or grep

Why would five hundred and five same as one?

Showing mass murder in a kid's book

A seasonal riddle

What is the period/term used describe Giuseppe Arcimboldo's style of painting?

python displays `n` instead of breaking a line



Why can't I get pgrep output right to variable on bash script?



2019 Community Moderator ElectionBash script doesn't TEE output to subdirectoryExiting a Bash script when a sudo child quitsConditional execution block with || and parentheses problemGet PID and return code from 1 line bash callWhy is “Doing an exit 130 is not the same as dying of SIGINT”?bash script: capturing tcp traffic on a remote server sometimes works, sometimes fails. No errorsWhat does typing a single exclamation mark do in Bash?Execute command and store everything to variable in bashWhy does bash 'read' exit with status 1?What does it mean when Duplicity exits with exit status 23?










1















I'm trying to make a script to either quit compton if it's running or start it if it's not running. I've read from man that it should exit 1 if process is found, so I've tried to make a script that uses that... However this just doesn't work, It starts if it's closed but doesn't close it. what am I doing wrong ??



#!/bin/bash


status=$(pgrep compton 2>&1)

if [[ $status == 1 ]];
then
killall compton
else
exec compton -b
fi

echo $status









share|improve this question









New contributor




Tube is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.
























    1















    I'm trying to make a script to either quit compton if it's running or start it if it's not running. I've read from man that it should exit 1 if process is found, so I've tried to make a script that uses that... However this just doesn't work, It starts if it's closed but doesn't close it. what am I doing wrong ??



    #!/bin/bash


    status=$(pgrep compton 2>&1)

    if [[ $status == 1 ]];
    then
    killall compton
    else
    exec compton -b
    fi

    echo $status









    share|improve this question









    New contributor




    Tube is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
    Check out our Code of Conduct.






















      1












      1








      1








      I'm trying to make a script to either quit compton if it's running or start it if it's not running. I've read from man that it should exit 1 if process is found, so I've tried to make a script that uses that... However this just doesn't work, It starts if it's closed but doesn't close it. what am I doing wrong ??



      #!/bin/bash


      status=$(pgrep compton 2>&1)

      if [[ $status == 1 ]];
      then
      killall compton
      else
      exec compton -b
      fi

      echo $status









      share|improve this question









      New contributor




      Tube is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
      Check out our Code of Conduct.












      I'm trying to make a script to either quit compton if it's running or start it if it's not running. I've read from man that it should exit 1 if process is found, so I've tried to make a script that uses that... However this just doesn't work, It starts if it's closed but doesn't close it. what am I doing wrong ??



      #!/bin/bash


      status=$(pgrep compton 2>&1)

      if [[ $status == 1 ]];
      then
      killall compton
      else
      exec compton -b
      fi

      echo $status






      bash stdout stderr exit-status pgrep






      share|improve this question









      New contributor




      Tube is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
      Check out our Code of Conduct.











      share|improve this question









      New contributor




      Tube is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
      Check out our Code of Conduct.









      share|improve this question




      share|improve this question








      edited 19 mins ago









      Kusalananda

      136k17257426




      136k17257426






      New contributor




      Tube is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
      Check out our Code of Conduct.









      asked 2 hours ago









      TubeTube

      61




      61




      New contributor




      Tube is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
      Check out our Code of Conduct.





      New contributor





      Tube is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
      Check out our Code of Conduct.






      Tube is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
      Check out our Code of Conduct.




















          2 Answers
          2






          active

          oldest

          votes


















          2














          You should control exit status of pgrep process which will be in $? variable. Or check if $status variable where you're storing the output of pgrep is f.e. non zero-length string. The script in the question checks whether string in variable status is "1"



          so



          #!/bin/bash
          pgrep compton >/dev/null

          if [[ $? -eq 0 ]]
          then
          killall compton
          else
          exec compton -b
          fi


          or



          #!/bin/bash
          status=$(pgrep compton 2>&1)

          if [[ -n "$status" ]]
          then
          killall compton
          else
          exec compton -b
          fi





          share|improve this answer






























            2














            You are getting the pgrep output in your status variable. It's just not the output that you expect it to be.



            pgrep outputs the process IDs (PIDs) of the processes matching the pattern that you give it. If there is a process whose name matches compton, then $status would be the PID of that process, or of those processes. pgrep also returns an exit status, but an exit status is not captured by a command substitution as a string.



            In your test, you compare $status against 1. It is unlikely that compton has PID 1.




            If you want to kill any compton process if they exist, and start compton -b if no compton process exists, you may do that with



            #!/bin/sh

            if ! pkill compton; then
            exec compton -b
            fi


            This uses the exit status of pkill. The pkill tool works in an equivalent way to pgrep (they are usually distributed and installed as a pair) but instead of outputting PIDs of matching processes like pgrep would do, pkill sends the TERM signal (by default) to the matching processes.



            The if keyword uses the exit status of the command that you use with it.



            The ! inverts the sense of the test so that



            • If pkill compton succeeds, it means that there was one or several compton processes that have now been killed, or at least signalled, and exec compton -b will not be executed.


            • If pkill compton fails (no process matched the name, or there was some internal error in pkill), the body of the if statement would call your exec compton -b, which would replace the shell process with that of compton -b.






            share|improve this answer
























              Your Answer








              StackExchange.ready(function()
              var channelOptions =
              tags: "".split(" "),
              id: "106"
              ;
              initTagRenderer("".split(" "), "".split(" "), channelOptions);

              StackExchange.using("externalEditor", function()
              // Have to fire editor after snippets, if snippets enabled
              if (StackExchange.settings.snippets.snippetsEnabled)
              StackExchange.using("snippets", function()
              createEditor();
              );

              else
              createEditor();

              );

              function createEditor()
              StackExchange.prepareEditor(
              heartbeatType: 'answer',
              autoActivateHeartbeat: false,
              convertImagesToLinks: false,
              noModals: true,
              showLowRepImageUploadWarning: true,
              reputationToPostImages: null,
              bindNavPrevention: true,
              postfix: "",
              imageUploader:
              brandingHtml: "Powered by u003ca class="icon-imgur-white" href="https://imgur.com/"u003eu003c/au003e",
              contentPolicyHtml: "User contributions licensed under u003ca href="https://creativecommons.org/licenses/by-sa/3.0/"u003ecc by-sa 3.0 with attribution requiredu003c/au003e u003ca href="https://stackoverflow.com/legal/content-policy"u003e(content policy)u003c/au003e",
              allowUrls: true
              ,
              onDemand: true,
              discardSelector: ".discard-answer"
              ,immediatelyShowMarkdownHelp:true
              );



              );






              Tube is a new contributor. Be nice, and check out our Code of Conduct.









              draft saved

              draft discarded


















              StackExchange.ready(
              function ()
              StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f507290%2fwhy-cant-i-get-pgrep-output-right-to-variable-on-bash-script%23new-answer', 'question_page');

              );

              Post as a guest















              Required, but never shown

























              2 Answers
              2






              active

              oldest

              votes








              2 Answers
              2






              active

              oldest

              votes









              active

              oldest

              votes






              active

              oldest

              votes









              2














              You should control exit status of pgrep process which will be in $? variable. Or check if $status variable where you're storing the output of pgrep is f.e. non zero-length string. The script in the question checks whether string in variable status is "1"



              so



              #!/bin/bash
              pgrep compton >/dev/null

              if [[ $? -eq 0 ]]
              then
              killall compton
              else
              exec compton -b
              fi


              or



              #!/bin/bash
              status=$(pgrep compton 2>&1)

              if [[ -n "$status" ]]
              then
              killall compton
              else
              exec compton -b
              fi





              share|improve this answer



























                2














                You should control exit status of pgrep process which will be in $? variable. Or check if $status variable where you're storing the output of pgrep is f.e. non zero-length string. The script in the question checks whether string in variable status is "1"



                so



                #!/bin/bash
                pgrep compton >/dev/null

                if [[ $? -eq 0 ]]
                then
                killall compton
                else
                exec compton -b
                fi


                or



                #!/bin/bash
                status=$(pgrep compton 2>&1)

                if [[ -n "$status" ]]
                then
                killall compton
                else
                exec compton -b
                fi





                share|improve this answer

























                  2












                  2








                  2







                  You should control exit status of pgrep process which will be in $? variable. Or check if $status variable where you're storing the output of pgrep is f.e. non zero-length string. The script in the question checks whether string in variable status is "1"



                  so



                  #!/bin/bash
                  pgrep compton >/dev/null

                  if [[ $? -eq 0 ]]
                  then
                  killall compton
                  else
                  exec compton -b
                  fi


                  or



                  #!/bin/bash
                  status=$(pgrep compton 2>&1)

                  if [[ -n "$status" ]]
                  then
                  killall compton
                  else
                  exec compton -b
                  fi





                  share|improve this answer













                  You should control exit status of pgrep process which will be in $? variable. Or check if $status variable where you're storing the output of pgrep is f.e. non zero-length string. The script in the question checks whether string in variable status is "1"



                  so



                  #!/bin/bash
                  pgrep compton >/dev/null

                  if [[ $? -eq 0 ]]
                  then
                  killall compton
                  else
                  exec compton -b
                  fi


                  or



                  #!/bin/bash
                  status=$(pgrep compton 2>&1)

                  if [[ -n "$status" ]]
                  then
                  killall compton
                  else
                  exec compton -b
                  fi






                  share|improve this answer












                  share|improve this answer



                  share|improve this answer










                  answered 2 hours ago









                  Jakub JindraJakub Jindra

                  307310




                  307310























                      2














                      You are getting the pgrep output in your status variable. It's just not the output that you expect it to be.



                      pgrep outputs the process IDs (PIDs) of the processes matching the pattern that you give it. If there is a process whose name matches compton, then $status would be the PID of that process, or of those processes. pgrep also returns an exit status, but an exit status is not captured by a command substitution as a string.



                      In your test, you compare $status against 1. It is unlikely that compton has PID 1.




                      If you want to kill any compton process if they exist, and start compton -b if no compton process exists, you may do that with



                      #!/bin/sh

                      if ! pkill compton; then
                      exec compton -b
                      fi


                      This uses the exit status of pkill. The pkill tool works in an equivalent way to pgrep (they are usually distributed and installed as a pair) but instead of outputting PIDs of matching processes like pgrep would do, pkill sends the TERM signal (by default) to the matching processes.



                      The if keyword uses the exit status of the command that you use with it.



                      The ! inverts the sense of the test so that



                      • If pkill compton succeeds, it means that there was one or several compton processes that have now been killed, or at least signalled, and exec compton -b will not be executed.


                      • If pkill compton fails (no process matched the name, or there was some internal error in pkill), the body of the if statement would call your exec compton -b, which would replace the shell process with that of compton -b.






                      share|improve this answer





























                        2














                        You are getting the pgrep output in your status variable. It's just not the output that you expect it to be.



                        pgrep outputs the process IDs (PIDs) of the processes matching the pattern that you give it. If there is a process whose name matches compton, then $status would be the PID of that process, or of those processes. pgrep also returns an exit status, but an exit status is not captured by a command substitution as a string.



                        In your test, you compare $status against 1. It is unlikely that compton has PID 1.




                        If you want to kill any compton process if they exist, and start compton -b if no compton process exists, you may do that with



                        #!/bin/sh

                        if ! pkill compton; then
                        exec compton -b
                        fi


                        This uses the exit status of pkill. The pkill tool works in an equivalent way to pgrep (they are usually distributed and installed as a pair) but instead of outputting PIDs of matching processes like pgrep would do, pkill sends the TERM signal (by default) to the matching processes.



                        The if keyword uses the exit status of the command that you use with it.



                        The ! inverts the sense of the test so that



                        • If pkill compton succeeds, it means that there was one or several compton processes that have now been killed, or at least signalled, and exec compton -b will not be executed.


                        • If pkill compton fails (no process matched the name, or there was some internal error in pkill), the body of the if statement would call your exec compton -b, which would replace the shell process with that of compton -b.






                        share|improve this answer



























                          2












                          2








                          2







                          You are getting the pgrep output in your status variable. It's just not the output that you expect it to be.



                          pgrep outputs the process IDs (PIDs) of the processes matching the pattern that you give it. If there is a process whose name matches compton, then $status would be the PID of that process, or of those processes. pgrep also returns an exit status, but an exit status is not captured by a command substitution as a string.



                          In your test, you compare $status against 1. It is unlikely that compton has PID 1.




                          If you want to kill any compton process if they exist, and start compton -b if no compton process exists, you may do that with



                          #!/bin/sh

                          if ! pkill compton; then
                          exec compton -b
                          fi


                          This uses the exit status of pkill. The pkill tool works in an equivalent way to pgrep (they are usually distributed and installed as a pair) but instead of outputting PIDs of matching processes like pgrep would do, pkill sends the TERM signal (by default) to the matching processes.



                          The if keyword uses the exit status of the command that you use with it.



                          The ! inverts the sense of the test so that



                          • If pkill compton succeeds, it means that there was one or several compton processes that have now been killed, or at least signalled, and exec compton -b will not be executed.


                          • If pkill compton fails (no process matched the name, or there was some internal error in pkill), the body of the if statement would call your exec compton -b, which would replace the shell process with that of compton -b.






                          share|improve this answer















                          You are getting the pgrep output in your status variable. It's just not the output that you expect it to be.



                          pgrep outputs the process IDs (PIDs) of the processes matching the pattern that you give it. If there is a process whose name matches compton, then $status would be the PID of that process, or of those processes. pgrep also returns an exit status, but an exit status is not captured by a command substitution as a string.



                          In your test, you compare $status against 1. It is unlikely that compton has PID 1.




                          If you want to kill any compton process if they exist, and start compton -b if no compton process exists, you may do that with



                          #!/bin/sh

                          if ! pkill compton; then
                          exec compton -b
                          fi


                          This uses the exit status of pkill. The pkill tool works in an equivalent way to pgrep (they are usually distributed and installed as a pair) but instead of outputting PIDs of matching processes like pgrep would do, pkill sends the TERM signal (by default) to the matching processes.



                          The if keyword uses the exit status of the command that you use with it.



                          The ! inverts the sense of the test so that



                          • If pkill compton succeeds, it means that there was one or several compton processes that have now been killed, or at least signalled, and exec compton -b will not be executed.


                          • If pkill compton fails (no process matched the name, or there was some internal error in pkill), the body of the if statement would call your exec compton -b, which would replace the shell process with that of compton -b.







                          share|improve this answer














                          share|improve this answer



                          share|improve this answer








                          edited 27 mins ago

























                          answered 1 hour ago









                          KusalanandaKusalananda

                          136k17257426




                          136k17257426




















                              Tube is a new contributor. Be nice, and check out our Code of Conduct.









                              draft saved

                              draft discarded


















                              Tube is a new contributor. Be nice, and check out our Code of Conduct.












                              Tube is a new contributor. Be nice, and check out our Code of Conduct.











                              Tube is a new contributor. Be nice, and check out our Code of Conduct.














                              Thanks for contributing an answer to Unix & Linux Stack Exchange!


                              • Please be sure to answer the question. Provide details and share your research!

                              But avoid


                              • Asking for help, clarification, or responding to other answers.

                              • Making statements based on opinion; back them up with references or personal experience.

                              To learn more, see our tips on writing great answers.




                              draft saved


                              draft discarded














                              StackExchange.ready(
                              function ()
                              StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f507290%2fwhy-cant-i-get-pgrep-output-right-to-variable-on-bash-script%23new-answer', 'question_page');

                              );

                              Post as a guest















                              Required, but never shown





















































                              Required, but never shown














                              Required, but never shown












                              Required, but never shown







                              Required, but never shown

































                              Required, but never shown














                              Required, but never shown












                              Required, but never shown







                              Required, but never shown







                              Popular posts from this blog

                              Prove that NP is closed under karp reduction?Space(n) not closed under Karp reductions - what about NTime(n)?Class P is closed under rotation?Prove or disprove that $NL$ is closed under polynomial many-one reductions$mathbfNC_2$ is closed under log-space reductionOn Karp reductionwhen can I know if a class (complexity) is closed under reduction (cook/karp)Check if class $PSPACE$ is closed under polyonomially space reductionIs NPSPACE also closed under polynomial-time reduction and under log-space reduction?Prove PSPACE is closed under complement?Prove PSPACE is closed under union?

                              名間水力發電廠 目录 沿革 設施 鄰近設施 註釋 外部連結 导航菜单23°50′10″N 120°42′41″E / 23.83611°N 120.71139°E / 23.83611; 120.7113923°50′10″N 120°42′41″E / 23.83611°N 120.71139°E / 23.83611; 120.71139計畫概要原始内容臺灣第一座BOT 模式開發的水力發電廠-名間水力電廠名間水力發電廠 水利署首件BOT案原始内容《小檔案》名間電廠 首座BOT水力發電廠原始内容名間電廠BOT - 經濟部水利署中區水資源局

                              Is my guitar’s action too high? Announcing the arrival of Valued Associate #679: Cesar Manara Planned maintenance scheduled April 23, 2019 at 23:30 UTC (7:30pm US/Eastern)Strings too stiff on a recently purchased acoustic guitar | Cort AD880CEIs the action of my guitar really high?Μy little finger is too weak to play guitarWith guitar, how long should I give my fingers to strengthen / callous?When playing a fret the guitar sounds mutedPlaying (Barre) chords up the guitar neckI think my guitar strings are wound too tight and I can't play barre chordsF barre chord on an SG guitarHow to find to the right strings of a barre chord by feel?High action on higher fret on my steel acoustic guitar